#pragma semicolon 1

#include <sourcemod>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [!vips]",
	author	= "wS",
	version = "1.3.4"
};

new Handle:g_hTrie; // иммунитет
new g_iFlag[25], g_iFlagCount;
new bool:g_bAdminIgnoreImmunity;

public OnPluginStart()
{
	LoadTranslations("vip_vips.phrases");

	new bool:Volk  = false;
	g_hTrie = CreateTrie();

	new Handle:kv = CreateKeyValues("vips");
	if (FileToKeyValues(kv, "cfg/vip/modules/vips/vips.txt"))
	{
		Volk = Zayac(kv, "COMMANDS");
		Zayac(kv,  "IMMUNITY_GROUP");
		Zayac(kv,  "IMMUNITY_STEAM");
		Zayac(kv,  "IMMUNITY_FLAGS");
	}
	CloseHandle(kv);

	if (!Volk)
		RegConsoleCmd("sm_vips", vips_cmd);

	if (!GetTrieSize(g_hTrie))
	{
		CloseHandle(g_hTrie);
		g_hTrie = INVALID_HANDLE;
	}
	
	new Handle:hCvar = CreateConVar("vips_admin_ignore_immunity", "1", "1 = Admin (flag ban) ignore immunity and see all VIP players\n0 = No");
	g_bAdminIgnoreImmunity = GetConVarInt(hCvar) == 1;
	HookConVarChange(hCvar,	CvarChanged);

	AutoExecConfig(true, "vips", "vip/modules/vips");
}

public CvarChanged(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	g_bAdminIgnoreImmunity = StringToInt(NewValue) == 1;
}

stock bool:Zayac(Handle:kv, const String:key[])
{
	KvRewind(kv);
	if (!KvJumpToKey(kv, key, false) || !KvGotoFirstSubKey(kv, false))
		return false;

	new bool:Volk = false;
	decl String:sInfo[64], AdminFlag:Flag;

	do
	{
		KvGetString(kv, "", sInfo, sizeof(sInfo), "");
		if (!TrimString(sInfo))
			continue;

		// COMMANDS
		if (key[0] == 'C')
		{
			RegConsoleCmd(sInfo, vips_cmd);
			Volk = true;
		}

		// IMMUNITY_GROUP + IMMUNITY_STEAM
		else if (key[9] != 'F')
			SetTrieValue(g_hTrie, sInfo, 1);

		// IMMUNITY_FLAGS
		else if (FindFlagByChar(sInfo[0], Flag))
		{
			g_iFlag[g_iFlagCount] = FlagToBit(Flag);
			if (++g_iFlagCount > 24)
				break;
		}
	}
	while (KvGotoNextKey(kv, false));

	return Volk;
}

stock bool:wS_Flood(client)
{
	static LastTime[MAXPLAYERS + 1];
	new x = GetTime();
	if (x == LastTime[client]) return true;
	LastTime[client] = x;
	return false;
}

public Action:vips_cmd(client, args)
{
	if (client > 0 && client <= MaxClients && !wS_Flood(client)) wS_ShowVipListMenu(client);
	return Plugin_Handled;
}

stock wS_ShowVipListMenu(client)
{
	new Handle:menu = CreateMenu(VipListMenu_CallBack);

	decl String:sText[64], String:name[MAX_NAME_LENGTH], String:group[GROUP_LENGTH], x, s, flags;
	new bool:bIgnoreImmunity = g_bAdminIgnoreImmunity && ((flags = GetUserFlagBits(client)) & ADMFLAG_BAN || flags & ADMFLAG_ROOT);
	new count = 0;

	for (new i = 1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i))
			continue;
		
		flags = VIP_GetFlags(i);
		if (!(flags & VCF_VIPMENUACCESS) && !(flags & VCF_VIPFREE) && !(flags & VCF_VIPPAUSE) && !(flags & VCF_HOLIDAY))
			continue;
		
		if (!VIP_GetGroupName(i, group, GROUP_LENGTH))
			group[0] = 0;
		
		//
		if (!bIgnoreImmunity)
		{
			if (g_iFlagCount > 0 && (x = GetUserFlagBits(i)) > 0)
			{
				for (s = 0; s < g_iFlagCount; s++)
				{
					if (x & g_iFlag[s])
					{
						x = 12345;
						break;
					}
				}
				if (x == 12345) // У игрока иммунитет, не показываем его.
					continue;
			}

			if (g_hTrie && ((group[0] && GetTrieValue(g_hTrie, group, x)) || (GetClientAuthId(i, AuthId_Steam2, sText, sizeof(sText)) && GetTrieValue(g_hTrie, sText, x))))
				continue;
		}
		//
		
		if (!GetClientName(i, name, MAX_NAME_LENGTH))
			strcopy(name, MAX_NAME_LENGTH, "Unknown");
		
		//
		if (flags & VCF_VIPFREE)
			FormatEx(sText, sizeof(sText), "%T", "free", client, name);
		
		else if (flags & VCF_VIPPAUSE)
			FormatEx(sText, sizeof(sText), "%T", "paused", client, name);
		
		else if (flags & VCF_HOLIDAY)
			FormatEx(sText, sizeof(sText), "%T", "holiday", client, name);
		
		else if (flags & VCF_VIP)
		{
			s = VIP_GetSeconds(i); // -2 = нет VIP прав, -1 = вечный VIP доступ, s = оставшиеся секунды VIP доступа
			if (s < 1 && s != -1) s = 1;
			
			if (flags & VCF_VIPTEST)
				FormatEx(sText, sizeof(sText), "%T", "test", client, name, s/3600/24, s/3600%24, s/60%60);
			else if (s > 0)
				FormatEx(sText, sizeof(sText), "%T", "vip time", client, name, s/3600/24, s/3600%24, s/60%60);
			else
				FormatEx(sText, sizeof(sText), "%T", "vip forever", client, name);
		}
		
		else if (flags & VCF_VIPBYFLAG)
			FormatEx(sText, sizeof(sText), "%T", "flag", client, name);
		
		else
			FormatEx(sText, sizeof(sText), "%T", "temp", client, name);
		//
		
		AddMenuItem(menu, "", sText, ITEMDRAW_DISABLED);
		++count;
	}

	if (count < 1)
	{
		FormatEx(sText, sizeof(sText), "%T", "not found", client);
		AddMenuItem(menu, "", sText, ITEMDRAW_DISABLED);
	}

	SetMenuTitle(menu, "%T\n \n", "title", client, count);
	DisplayMenu(menu, client, 0);
}

public VipListMenu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_End)
		CloseHandle(menu);
}